----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:50:41 10/29/2012 
-- Design Name: 
-- Module Name:    main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity main is

port( clk,we0,we1,we2,sw0,sw1,sw2 : in STD_LOGIC;
		adr : in std_logic_vector(3 downto 0));
		

end main;

architecture Behavioral of main is

component RAM port (CLK,WE : IN STD_LOGIC;
    adr: IN  STD_LOGIC_VECTOR(3 DOWNTO 0);
    di:  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
    do:  OUT STD_LOGIC_VECTOR(7 DOWNTO 0));
END component;

component REG Port ( 	din : in  STD_LOGIC_VECTOR (7 downto 0);				
           clk : in  STD_LOGIC;
           we : in  STD_LOGIC;
           dout : out  STD_LOGIC_VECTOR (7 downto 0));
end component;

component mux Port ( din1 : in  STD_LOGIC_VECTOR (7 downto 0);
           din2 : in  STD_LOGIC_VECTOR (7 downto 0);
           dout : out  STD_LOGIC_VECTOR (7 downto 0);
           sw : in  STD_LOGIC);
end component;

signal mi1,mi2,mi3,ma1,ma2,ma3 : std_logic_vector ( 7 downto 0);

begin

Mux1 : mux PORT MAP(mi1,mi2,ma1,sw0);

Mux2 : mux PORT MAP(mi1,mi3,ma2,sw1);

Mux3 : mux port Map(mi2,mi3,ma3,sw2);

regi1 : REG port map(ma2,clk,we1,mi2);
regi2 : REG port map(ma3,clk,we2,mi1);

R : RAM port map(clk,we0,adr,mi3,ma1);




end Behavioral;

