----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:10:14 10/29/2012 
-- Design Name: 
-- Module Name:    auto - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity auto is 
port(
adr1 : in std_logic_vector(3 downto 0);
adr2 : in std_logic_vector(3 downto 0);
clk,start: in std_logic);




end auto;

architecture Behavioral of auto is

component main port( 
		clk,we1,we2,we0,sw0,sw1,sw2 : in STD_LOGIC;
		adr : in std_logic_vector(3 downto 0));
end component;

signal status : STD_LOGIC_VECTOR (2 downto 0):= "000";
SIGNAL ad: STD_LOGIC_VECTOR (3 DOWNTO 0);
SIGNAL we0,we1,we2,sw0,sw1,sw2 : STD_LOGIC;

begin

K1 : main port map (clk,we0,we1,we2,sw0,sw1,sw2,ad);
	
	process(clk)
	
	begin
	
	if (clk='1' and clk'event) then
	
			if ( start='1' and status="000") then 
						ad<=adr1;
						we1<='1';
						sw1<='1';
						status<="001";
				elsif(status="001") then
						ad<=adr2;
						we1<='0';
						we2<='1';
						sw2<='1';
						status<="010";
				elsif(status="010") then
						ad<=adr2;
						we2<='0';
						we0<='1';
						sw0<='1';
						status<="011";
				elsif(status="011") then 
						ad<=adr1;
						we0<='1';
						sw0<='0';
						status<="100";
				elsif(status="100") then
						we0<='0';
						status<="000";
			end if;
			end if;
			end process;
						

end Behavioral;

